package astia;

import demo.d5.Astia;
import static demo.d5.AstiaPeli.*;
import fi.jyu.mit.ohj2.*;

/**
 * Astiapeli jossa kytetn TaikaAstiaa
 * @author  Vesa Lappalainen
 * @version 1.0, 09.02.2003
 */
public class AstiaPeliTaikaAstialla {
    // #PACKAGEIMPORT    
    // #import fi.jyu.mit.ohj2.Suuntaaja;

    /**
     * Testataan AstiaPeli-luokkaa
     * @param args ei kytss
     * @example
     * <pre name="test">
     * Suuntaaja.StringInput si = new Suuntaaja.StringInput("");  
     * Suuntaaja.StringOutput so = new Suuntaaja.StringOutput();
     * 
     * si.input(" 8\n8 5\n4 5\n\n");  
     * main(null);
     * String tulos =
     *   "Kytsssi on 5.0 sek 8.0 litran astiat ja mpari (0.0 l)\n"+
     *   "5.0 litran astiassa on 0.0 litraa nestett\n" +
     *   "8.0 litran astiassa on 0.0 litraa nestett\n" +
     *   "Mist kaadetaan ja mihin >"                   + // NOPMD
     *   "5.0 litran astiassa on 0.0 litraa nestett\n" +
     *   "8.0 litran astiassa on 8.0 litraa nestett\n" +
     *   "Mist kaadetaan ja mihin >"                   +
     *   "5.0 litran astiassa on 5.0 litraa nestett\n" +
     *   "8.0 litran astiassa on 3.0 litraa nestett\n" +
     *   "Mist kaadetaan ja mihin >"                   +
     *   "Nime ei tunneta: 4 tai 5\n"                  +
     *   "Tunnetaan nimet: \n"                          + 
     *   " 5 8 \n"                                     +
     *   "5.0 litran astiassa on 5.0 litraa nestett\n" +
     *   "8.0 litran astiassa on 3.0 litraa nestett\n" +
     *   "Mist kaadetaan ja mihin >";
     * 
     * so.ero(tulos) === null; 
     * si.palauta(); so.palauta();
     * </pre>
     */
    public static void main(String[] args) {
        Astia ampari = new TaikaAstia("");
        Astia astiat[] = { ampari, new Astia("5", 5), new Astia("8", 8) };

        tulostaOhje(astiat);

        while (true) {
            for (int i = 1; i < astiat.length; i++)
                System.out.println(astiat[i].getTilavuus()
                        + " litran astiassa on " + astiat[i].getMaara()
                        + " litraa nestett");
            String rivi = Syotto.kysy("Mist kaadetaan ja mihin");
            if (rivi.length() == 0)
                break;

            StringBuffer sb = new StringBuffer(rivi); // NOPMD
            String mista = Mjonot.erota(sb);
            String mihin = Mjonot.erota(sb);
            int imista = etsi(astiat, mista);
            int imihin = etsi(astiat, mihin);

            if ((imista < 0) || (imihin < 0))
                nimiOhje(astiat, mista, mihin);
            else
                astiat[imista].kaada(astiat[imihin]);
        }
    }

    
    /**
     * Taika-astia josta riitt aina nestett ja johon voi aina kaataa
     * @author vesal
     * @version 17.2.2011
     */
    public static class TaikaAstia extends Astia { // is a
        /**
         * @param nimi astian nimi
         */
        public TaikaAstia(String nimi) {
            super(nimi, 0);
        }


        @Override
        public double getMaara() {
            return Double.MAX_VALUE;
        }


        @Override
        public double getTyhjaa() {
            return Double.MAX_VALUE;
        }

    }

}